/*
 * generated by Xtext
 */
package org.eclipse.etrice.core.serializer;

import com.google.inject.Inject;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.etrice.core.services.RoomGrammarAccess;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.GroupAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class RoomSyntacticSequencer extends AbstractSyntacticSequencer {

	protected RoomGrammarAccess grammarAccess;
	protected AbstractElementAlias match_ActorClass___BehaviorKeyword_9_0_LeftCurlyBracketKeyword_9_2_RightCurlyBracketKeyword_9_6__q;
	protected AbstractElementAlias match_ActorClass___InterfaceKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q;
	protected AbstractElementAlias match_ActorClass___StructureKeyword_8_0_LeftCurlyBracketKeyword_8_2_RightCurlyBracketKeyword_8_7__q;
	protected AbstractElementAlias match_ActorInstanceMapping___LeftCurlyBracketKeyword_4_0_RightCurlyBracketKeyword_4_2__q;
	protected AbstractElementAlias match_ContinuationTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q;
	protected AbstractElementAlias match_InitialTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q;
	protected AbstractElementAlias match_Message___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q;
	protected AbstractElementAlias match_PortOperation___ColonKeyword_5_0_0_VoidKeyword_5_0_1_0__q;
	protected AbstractElementAlias match_ProtocolClass___IncomingKeyword_10_0_LeftCurlyBracketKeyword_10_1_RightCurlyBracketKeyword_10_3__q;
	protected AbstractElementAlias match_ProtocolClass___OutgoingKeyword_11_0_LeftCurlyBracketKeyword_11_1_RightCurlyBracketKeyword_11_3__q;
	protected AbstractElementAlias match_SimpleState___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_6__q;
	protected AbstractElementAlias match_StandardOperation___ColonKeyword_6_0_VoidKeyword_6_1_0__q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (RoomGrammarAccess) access;
		match_ActorClass___BehaviorKeyword_9_0_LeftCurlyBracketKeyword_9_2_RightCurlyBracketKeyword_9_6__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getActorClassAccess().getBehaviorKeyword_9_0()), new TokenAlias(false, false, grammarAccess.getActorClassAccess().getLeftCurlyBracketKeyword_9_2()), new TokenAlias(false, false, grammarAccess.getActorClassAccess().getRightCurlyBracketKeyword_9_6()));
		match_ActorClass___InterfaceKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getActorClassAccess().getInterfaceKeyword_7_0()), new TokenAlias(false, false, grammarAccess.getActorClassAccess().getLeftCurlyBracketKeyword_7_1()), new TokenAlias(false, false, grammarAccess.getActorClassAccess().getRightCurlyBracketKeyword_7_3()));
		match_ActorClass___StructureKeyword_8_0_LeftCurlyBracketKeyword_8_2_RightCurlyBracketKeyword_8_7__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getActorClassAccess().getStructureKeyword_8_0()), new TokenAlias(false, false, grammarAccess.getActorClassAccess().getLeftCurlyBracketKeyword_8_2()), new TokenAlias(false, false, grammarAccess.getActorClassAccess().getRightCurlyBracketKeyword_8_7()));
		match_ActorInstanceMapping___LeftCurlyBracketKeyword_4_0_RightCurlyBracketKeyword_4_2__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getActorInstanceMappingAccess().getLeftCurlyBracketKeyword_4_0()), new TokenAlias(false, false, grammarAccess.getActorInstanceMappingAccess().getRightCurlyBracketKeyword_4_2()));
		match_ContinuationTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getContinuationTransitionAccess().getLeftCurlyBracketKeyword_7_0()), new TokenAlias(false, false, grammarAccess.getContinuationTransitionAccess().getRightCurlyBracketKeyword_7_3()));
		match_InitialTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getInitialTransitionAccess().getLeftCurlyBracketKeyword_7_0()), new TokenAlias(false, false, grammarAccess.getInitialTransitionAccess().getRightCurlyBracketKeyword_7_3()));
		match_Message___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getMessageAccess().getLeftParenthesisKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getMessageAccess().getRightParenthesisKeyword_3_2()));
		match_PortOperation___ColonKeyword_5_0_0_VoidKeyword_5_0_1_0__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPortOperationAccess().getColonKeyword_5_0_0()), new TokenAlias(false, false, grammarAccess.getPortOperationAccess().getVoidKeyword_5_0_1_0()));
		match_ProtocolClass___IncomingKeyword_10_0_LeftCurlyBracketKeyword_10_1_RightCurlyBracketKeyword_10_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getProtocolClassAccess().getIncomingKeyword_10_0()), new TokenAlias(false, false, grammarAccess.getProtocolClassAccess().getLeftCurlyBracketKeyword_10_1()), new TokenAlias(false, false, grammarAccess.getProtocolClassAccess().getRightCurlyBracketKeyword_10_3()));
		match_ProtocolClass___OutgoingKeyword_11_0_LeftCurlyBracketKeyword_11_1_RightCurlyBracketKeyword_11_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getProtocolClassAccess().getOutgoingKeyword_11_0()), new TokenAlias(false, false, grammarAccess.getProtocolClassAccess().getLeftCurlyBracketKeyword_11_1()), new TokenAlias(false, false, grammarAccess.getProtocolClassAccess().getRightCurlyBracketKeyword_11_3()));
		match_SimpleState___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_6__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getSimpleStateAccess().getLeftCurlyBracketKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getSimpleStateAccess().getRightCurlyBracketKeyword_3_6()));
		match_StandardOperation___ColonKeyword_6_0_VoidKeyword_6_1_0__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getStandardOperationAccess().getColonKeyword_6_0()), new TokenAlias(false, false, grammarAccess.getStandardOperationAccess().getVoidKeyword_6_1_0()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_ActorClass___BehaviorKeyword_9_0_LeftCurlyBracketKeyword_9_2_RightCurlyBracketKeyword_9_6__q.equals(syntax))
				emit_ActorClass___BehaviorKeyword_9_0_LeftCurlyBracketKeyword_9_2_RightCurlyBracketKeyword_9_6__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ActorClass___InterfaceKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q.equals(syntax))
				emit_ActorClass___InterfaceKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ActorClass___StructureKeyword_8_0_LeftCurlyBracketKeyword_8_2_RightCurlyBracketKeyword_8_7__q.equals(syntax))
				emit_ActorClass___StructureKeyword_8_0_LeftCurlyBracketKeyword_8_2_RightCurlyBracketKeyword_8_7__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ActorInstanceMapping___LeftCurlyBracketKeyword_4_0_RightCurlyBracketKeyword_4_2__q.equals(syntax))
				emit_ActorInstanceMapping___LeftCurlyBracketKeyword_4_0_RightCurlyBracketKeyword_4_2__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ContinuationTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q.equals(syntax))
				emit_ContinuationTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_InitialTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q.equals(syntax))
				emit_InitialTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Message___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q.equals(syntax))
				emit_Message___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_PortOperation___ColonKeyword_5_0_0_VoidKeyword_5_0_1_0__q.equals(syntax))
				emit_PortOperation___ColonKeyword_5_0_0_VoidKeyword_5_0_1_0__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ProtocolClass___IncomingKeyword_10_0_LeftCurlyBracketKeyword_10_1_RightCurlyBracketKeyword_10_3__q.equals(syntax))
				emit_ProtocolClass___IncomingKeyword_10_0_LeftCurlyBracketKeyword_10_1_RightCurlyBracketKeyword_10_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ProtocolClass___OutgoingKeyword_11_0_LeftCurlyBracketKeyword_11_1_RightCurlyBracketKeyword_11_3__q.equals(syntax))
				emit_ProtocolClass___OutgoingKeyword_11_0_LeftCurlyBracketKeyword_11_1_RightCurlyBracketKeyword_11_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_SimpleState___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_6__q.equals(syntax))
				emit_SimpleState___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_6__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_StandardOperation___ColonKeyword_6_0_VoidKeyword_6_1_0__q.equals(syntax))
				emit_StandardOperation___ColonKeyword_6_0_VoidKeyword_6_1_0__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('Behavior' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     actorRefs+=ActorRef '}' (ambiguity) '}' (rule end)
	 *     annotations+=Annotation ('Interface' '{' '}')? ('Structure' '{' '}')? (ambiguity) '}' (rule end)
	 *     attributes+=Attribute '}' (ambiguity) '}' (rule end)
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? ('Structure' '{' '}')? (ambiguity) '}' (rule end)
	 *     bindings+=Binding '}' (ambiguity) '}' (rule end)
	 *     connections+=LayerConnection '}' (ambiguity) '}' (rule end)
	 *     docu=Documentation '{' ('Interface' '{' '}')? ('Structure' '{' '}')? (ambiguity) '}' (rule end)
	 *     externalPorts+=ExternalPort '}' (ambiguity) '}' (rule end)
	 *     interfacePorts+=Port '}' ('Structure' '{' '}')? (ambiguity) '}' (rule end)
	 *     internalPorts+=Port '}' (ambiguity) '}' (rule end)
	 *     name=ID '{' ('Interface' '{' '}')? ('Structure' '{' '}')? (ambiguity) '}' (rule end)
	 *     serviceAccessPoints+=SAP '}' (ambiguity) '}' (rule end)
	 *     serviceImplementations+=ServiceImplementation '}' (ambiguity) '}' (rule end)
	 *     serviceProvisionPoints+=SPP '}' ('Structure' '{' '}')? (ambiguity) '}' (rule end)
	 *     structureDocu=Documentation '{' '}' (ambiguity) '}' (rule end)
	 *     userCode1=DetailCode '}' (ambiguity) '}' (rule end)
	 *     userCode2=DetailCode '}' (ambiguity) '}' (rule end)
	 *     userCode3=DetailCode '}' (ambiguity) '}' (rule end)
	 
	 * </pre>
	 */
	protected void emit_ActorClass___BehaviorKeyword_9_0_LeftCurlyBracketKeyword_9_2_RightCurlyBracketKeyword_9_6__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('Interface' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' 'usercode1' userCode1=DetailCode
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' 'usercode2' userCode2=DetailCode
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' 'usercode3' userCode3=DetailCode
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' actorRefs+=ActorRef
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' attributes+=Attribute
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' bindings+=Binding
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' connections+=LayerConnection
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' externalPorts+=ExternalPort
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' internalPorts+=Port
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' serviceAccessPoints+=SAP
	 *     annotations+=Annotation (ambiguity) 'Structure' '{' serviceImplementations+=ServiceImplementation
	 *     annotations+=Annotation (ambiguity) 'Structure' structureDocu=Documentation
	 *     annotations+=Annotation (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     annotations+=Annotation (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' operations+=StandardOperation
	 *     annotations+=Annotation (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' stateMachine=StateMachine
	 *     annotations+=Annotation (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' structors+=ClassStructor
	 *     annotations+=Annotation (ambiguity) ('Structure' '{' '}')? 'Behavior' behaviorDocu=Documentation
	 *     annotations+=Annotation (ambiguity) ('Structure' '{' '}')? ('Behavior' '{' '}')? '}' (rule end)
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' 'usercode1' userCode1=DetailCode
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' 'usercode2' userCode2=DetailCode
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' 'usercode3' userCode3=DetailCode
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' actorRefs+=ActorRef
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' attributes+=Attribute
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' bindings+=Binding
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' connections+=LayerConnection
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' externalPorts+=ExternalPort
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' internalPorts+=Port
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' serviceAccessPoints+=SAP
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' '{' serviceImplementations+=ServiceImplementation
	 *     base=[ActorClass|FQN] '{' (ambiguity) 'Structure' structureDocu=Documentation
	 *     base=[ActorClass|FQN] '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     base=[ActorClass|FQN] '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' operations+=StandardOperation
	 *     base=[ActorClass|FQN] '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' stateMachine=StateMachine
	 *     base=[ActorClass|FQN] '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' structors+=ClassStructor
	 *     base=[ActorClass|FQN] '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' behaviorDocu=Documentation
	 *     base=[ActorClass|FQN] '{' (ambiguity) ('Structure' '{' '}')? ('Behavior' '{' '}')? '}' (rule end)
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' 'usercode1' userCode1=DetailCode
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' 'usercode2' userCode2=DetailCode
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' 'usercode3' userCode3=DetailCode
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' actorRefs+=ActorRef
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' attributes+=Attribute
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' bindings+=Binding
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' connections+=LayerConnection
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' externalPorts+=ExternalPort
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' internalPorts+=Port
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' serviceAccessPoints+=SAP
	 *     docu=Documentation '{' (ambiguity) 'Structure' '{' serviceImplementations+=ServiceImplementation
	 *     docu=Documentation '{' (ambiguity) 'Structure' structureDocu=Documentation
	 *     docu=Documentation '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     docu=Documentation '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' operations+=StandardOperation
	 *     docu=Documentation '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' stateMachine=StateMachine
	 *     docu=Documentation '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' structors+=ClassStructor
	 *     docu=Documentation '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' behaviorDocu=Documentation
	 *     docu=Documentation '{' (ambiguity) ('Structure' '{' '}')? ('Behavior' '{' '}')? '}' (rule end)
	 *     name=ID '{' (ambiguity) 'Structure' '{' 'usercode1' userCode1=DetailCode
	 *     name=ID '{' (ambiguity) 'Structure' '{' 'usercode2' userCode2=DetailCode
	 *     name=ID '{' (ambiguity) 'Structure' '{' 'usercode3' userCode3=DetailCode
	 *     name=ID '{' (ambiguity) 'Structure' '{' actorRefs+=ActorRef
	 *     name=ID '{' (ambiguity) 'Structure' '{' attributes+=Attribute
	 *     name=ID '{' (ambiguity) 'Structure' '{' bindings+=Binding
	 *     name=ID '{' (ambiguity) 'Structure' '{' connections+=LayerConnection
	 *     name=ID '{' (ambiguity) 'Structure' '{' externalPorts+=ExternalPort
	 *     name=ID '{' (ambiguity) 'Structure' '{' internalPorts+=Port
	 *     name=ID '{' (ambiguity) 'Structure' '{' serviceAccessPoints+=SAP
	 *     name=ID '{' (ambiguity) 'Structure' '{' serviceImplementations+=ServiceImplementation
	 *     name=ID '{' (ambiguity) 'Structure' structureDocu=Documentation
	 *     name=ID '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     name=ID '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' operations+=StandardOperation
	 *     name=ID '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' stateMachine=StateMachine
	 *     name=ID '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' '{' structors+=ClassStructor
	 *     name=ID '{' (ambiguity) ('Structure' '{' '}')? 'Behavior' behaviorDocu=Documentation
	 *     name=ID '{' (ambiguity) ('Structure' '{' '}')? ('Behavior' '{' '}')? '}' (rule end)
	 
	 * </pre>
	 */
	protected void emit_ActorClass___InterfaceKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('Structure' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     annotations+=Annotation ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     annotations+=Annotation ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' operations+=StandardOperation
	 *     annotations+=Annotation ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' stateMachine=StateMachine
	 *     annotations+=Annotation ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' structors+=ClassStructor
	 *     annotations+=Annotation ('Interface' '{' '}')? (ambiguity) 'Behavior' behaviorDocu=Documentation
	 *     annotations+=Annotation ('Interface' '{' '}')? (ambiguity) ('Behavior' '{' '}')? '}' (rule end)
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' operations+=StandardOperation
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' stateMachine=StateMachine
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' structors+=ClassStructor
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' behaviorDocu=Documentation
	 *     base=[ActorClass|FQN] '{' ('Interface' '{' '}')? (ambiguity) ('Behavior' '{' '}')? '}' (rule end)
	 *     docu=Documentation '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     docu=Documentation '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' operations+=StandardOperation
	 *     docu=Documentation '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' stateMachine=StateMachine
	 *     docu=Documentation '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' structors+=ClassStructor
	 *     docu=Documentation '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' behaviorDocu=Documentation
	 *     docu=Documentation '{' ('Interface' '{' '}')? (ambiguity) ('Behavior' '{' '}')? '}' (rule end)
	 *     interfacePorts+=Port '}' (ambiguity) 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     interfacePorts+=Port '}' (ambiguity) 'Behavior' '{' operations+=StandardOperation
	 *     interfacePorts+=Port '}' (ambiguity) 'Behavior' '{' stateMachine=StateMachine
	 *     interfacePorts+=Port '}' (ambiguity) 'Behavior' '{' structors+=ClassStructor
	 *     interfacePorts+=Port '}' (ambiguity) 'Behavior' behaviorDocu=Documentation
	 *     interfacePorts+=Port '}' (ambiguity) ('Behavior' '{' '}')? '}' (rule end)
	 *     name=ID '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     name=ID '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' operations+=StandardOperation
	 *     name=ID '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' stateMachine=StateMachine
	 *     name=ID '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' '{' structors+=ClassStructor
	 *     name=ID '{' ('Interface' '{' '}')? (ambiguity) 'Behavior' behaviorDocu=Documentation
	 *     name=ID '{' ('Interface' '{' '}')? (ambiguity) ('Behavior' '{' '}')? '}' (rule end)
	 *     serviceProvisionPoints+=SPP '}' (ambiguity) 'Behavior' '{' behaviorAnnotations+=Annotation
	 *     serviceProvisionPoints+=SPP '}' (ambiguity) 'Behavior' '{' operations+=StandardOperation
	 *     serviceProvisionPoints+=SPP '}' (ambiguity) 'Behavior' '{' stateMachine=StateMachine
	 *     serviceProvisionPoints+=SPP '}' (ambiguity) 'Behavior' '{' structors+=ClassStructor
	 *     serviceProvisionPoints+=SPP '}' (ambiguity) 'Behavior' behaviorDocu=Documentation
	 *     serviceProvisionPoints+=SPP '}' (ambiguity) ('Behavior' '{' '}')? '}' (rule end)
	 
	 * </pre>
	 */
	protected void emit_ActorClass___StructureKeyword_8_0_LeftCurlyBracketKeyword_8_2_RightCurlyBracketKeyword_8_7__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     thread=[LogicalThread|ID] (ambiguity) (rule end)
	 
	 * </pre>
	 */
	protected void emit_ActorInstanceMapping___LeftCurlyBracketKeyword_4_0_RightCurlyBracketKeyword_4_2__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     docu=Documentation (ambiguity) (rule end)
	 *     to=TransitionTerminal (ambiguity) (rule end)
	 
	 * </pre>
	 */
	protected void emit_ContinuationTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     docu=Documentation (ambiguity) (rule end)
	 *     to=TransitionTerminal (ambiguity) (rule end)
	 
	 * </pre>
	 */
	protected void emit_InitialTransition___LeftCurlyBracketKeyword_7_0_RightCurlyBracketKeyword_7_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('(' ')')?
	 *
	 * This ambiguous syntax occurs at:
	 *     name=ID (ambiguity) (rule end)
	 *     name=ID (ambiguity) annotations+=Annotation
	 *     name=ID (ambiguity) docu=Documentation
	 
	 * </pre>
	 */
	protected void emit_Message___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     (':' 'void')?
	 *
	 * This ambiguous syntax occurs at:
	 *     arguments+=VarDecl ')' (ambiguity) detailCode=DetailCode
	 *     arguments+=VarDecl ')' (ambiguity) docu=Documentation
	 *     name=ID '(' ')' (ambiguity) detailCode=DetailCode
	 *     name=ID '(' ')' (ambiguity) docu=Documentation
	 
	 * </pre>
	 */
	protected void emit_PortOperation___ColonKeyword_5_0_0_VoidKeyword_5_0_1_0__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('incoming' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     annotations+=Annotation (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     annotations+=Annotation (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     annotations+=Annotation (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     annotations+=Annotation (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     annotations+=Annotation (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 *     base=[ProtocolClass|FQN] '{' (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     base=[ProtocolClass|FQN] '{' (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     base=[ProtocolClass|FQN] '{' (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     base=[ProtocolClass|FQN] '{' (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     base=[ProtocolClass|FQN] '{' (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 *     docu=Documentation '{' (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     docu=Documentation '{' (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     docu=Documentation '{' (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     docu=Documentation '{' (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     docu=Documentation '{' (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 *     name=ID '{' (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     name=ID '{' (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     name=ID '{' (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     name=ID '{' (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     name=ID '{' (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 *     userCode1=DetailCode (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     userCode1=DetailCode (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     userCode1=DetailCode (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     userCode1=DetailCode (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     userCode1=DetailCode (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 *     userCode2=DetailCode (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     userCode2=DetailCode (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     userCode2=DetailCode (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     userCode2=DetailCode (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     userCode2=DetailCode (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 *     userCode3=DetailCode (ambiguity) 'outgoing' '{' outgoingMessages+=Message
	 *     userCode3=DetailCode (ambiguity) ('outgoing' '{' '}')? 'conjugated' 'PortClass' conjugated=PortClass
	 *     userCode3=DetailCode (ambiguity) ('outgoing' '{' '}')? 'regular' 'PortClass' regular=PortClass
	 *     userCode3=DetailCode (ambiguity) ('outgoing' '{' '}')? '}' (rule end)
	 *     userCode3=DetailCode (ambiguity) ('outgoing' '{' '}')? semantics=ProtocolSemantics
	 
	 * </pre>
	 */
	protected void emit_ProtocolClass___IncomingKeyword_10_0_LeftCurlyBracketKeyword_10_1_RightCurlyBracketKeyword_10_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('outgoing' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     annotations+=Annotation ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     annotations+=Annotation ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     annotations+=Annotation ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     annotations+=Annotation ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 *     base=[ProtocolClass|FQN] '{' ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     base=[ProtocolClass|FQN] '{' ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     base=[ProtocolClass|FQN] '{' ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     base=[ProtocolClass|FQN] '{' ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 *     docu=Documentation '{' ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     docu=Documentation '{' ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     docu=Documentation '{' ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     docu=Documentation '{' ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 *     incomingMessages+=Message '}' (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     incomingMessages+=Message '}' (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     incomingMessages+=Message '}' (ambiguity) '}' (rule end)
	 *     incomingMessages+=Message '}' (ambiguity) semantics=ProtocolSemantics
	 *     name=ID '{' ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     name=ID '{' ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     name=ID '{' ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     name=ID '{' ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 *     userCode1=DetailCode ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     userCode1=DetailCode ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     userCode1=DetailCode ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     userCode1=DetailCode ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 *     userCode2=DetailCode ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     userCode2=DetailCode ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     userCode2=DetailCode ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     userCode2=DetailCode ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 *     userCode3=DetailCode ('incoming' '{' '}')? (ambiguity) 'conjugated' 'PortClass' conjugated=PortClass
	 *     userCode3=DetailCode ('incoming' '{' '}')? (ambiguity) 'regular' 'PortClass' regular=PortClass
	 *     userCode3=DetailCode ('incoming' '{' '}')? (ambiguity) '}' (rule end)
	 *     userCode3=DetailCode ('incoming' '{' '}')? (ambiguity) semantics=ProtocolSemantics
	 
	 * </pre>
	 */
	protected void emit_ProtocolClass___OutgoingKeyword_11_0_LeftCurlyBracketKeyword_11_1_RightCurlyBracketKeyword_11_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     ('{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     docu=Documentation (ambiguity) (rule end)
	 *     name=ID (ambiguity) (rule end)
	 
	 * </pre>
	 */
	protected void emit_SimpleState___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_6__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     (':' 'void')?
	 *
	 * This ambiguous syntax occurs at:
	 *     arguments+=VarDecl ')' (ambiguity) detailCode=DetailCode
	 *     arguments+=VarDecl ')' (ambiguity) docu=Documentation
	 *     name=ID '(' ')' (ambiguity) detailCode=DetailCode
	 *     name=ID '(' ')' (ambiguity) docu=Documentation
	 
	 * </pre>
	 */
	protected void emit_StandardOperation___ColonKeyword_6_0_VoidKeyword_6_1_0__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
